xquery version "3.1";

(:~
 : This module provides the API endpoint for publishing texts.
 :
 : @version 1.0 (2024-05-06)
 : @status stable
 : @author Max-Ferdinand Zeterberg
 :)
module namespace rest-publish="https://mollenhauer-edition.de/ns/rest-publish";

import module namespace config="https://sade.textgrid.de/ns/config" at "/db/apps/sade/config.xqm";
import module namespace tgconnect="https://sade.textgrid.de/ns/connect" at "../../textgrid/connect.xqm";

declare
    %rest:path("api/kmgPublish/{$TGURI}")
    %rest:GET
    %rest:form-param("sid", "{$sid}")
function rest-publish:publish($TGURI as xs:string*, $sid as xs:string*)
as item()*
{
    if (doc-available(concat($config:tei, $TGURI, '.xml'))) then
        try {
            let $publish := tgconnect:publish(concat("textgrid:", $TGURI), $sid, "data", "admin", "", "textgrid", "", false())
            return
                element report {
                    'Document with TGURI ' || $TGURI || ' has been updated.'
                }
        } catch * {
            element error {
                'Document with TGURI ' || $TGURI || ' could not be updated for unknown reason.'
            }
        }
    else
        try {
            let $publish := tgconnect:publish(concat("textgrid:", $TGURI), $sid, "data", "admin", "", "textgrid", "", false())
            return
                element report {
                    'Document with TGURI ' || $TGURI || ' has been published.'
                }
        } catch * {
            element error {
                'Document with TGURI ' || $TGURI || ' could not be published for unknown reason.'
            }
        }
};